events, cards, page_num = {}, nil, nil


function events:ADDON_LOADED(...)
	if select(1, ...) == "LootInfo" then 
		print("LootInfo: Loaded v"..VERSION_NUMBER)
		SetupWindow()
		if UI_OPEN > 0 then UIShow() else UIHide() end
		TableUpdate()
	end

end

function events:PLAYER_ENTERING_WORLD(...)
	SetupWindow()
	if UI_OPEN > 0 then UIShow() else UIHide() end
	TableUpdate()
end

function events:CHAT_MSG_LOOT(...)
	local lootstring, _, _, _, player = ...
	if string.find(lootstring, "receive") == nil or (PLAYER_ONLY == 1 and player ~= UnitName("player"))then return end
	local itemLink = string.match(lootstring,"|%x+|Hitem:.-|h.-|h|r")
	local itemAmount = string.match(string.gsub(lootstring, "|%x+|Hitem:.-|h.-|h|r", ""), "%d+")
	local itemString = string.match(itemLink, "item[%-?%d:]+")
	local itemName, _, quality, _, _, class, subclass, stackCount, equipSlot, texture, _, ClassID, SubClassID = GetItemInfo(itemString)
	local iid = {GetInstanceInfo()}
	if RAID_ONLY == 1 and RAID_IID[iid[8]] == nil then return end
	if quality < MIN_QUALITY then return end
	if itemAmount == nil then itemAmount = 1 end
	InsertTable(player, itemLink, itemName, itemAmount, quality)
end

function events:PLAYER_LEAVING_WORLD(...)
 -- handle PLAYER_LEAVING_WORLD here
end

function InsertTable(_player, _item, _itemStr, _itemAmount, _quality)
	table.insert(players, _player)
	table.insert(items, _item)
	table.insert(times, date("%m/%d/%y %H:%M:%S"))
	table.insert(itemStr, _itemStr)
	table.insert(zones, GetZoneText())
	table.insert(amounts, _itemAmount )
	table.insert(qualities, tonumber(_quality) )
	
	TableUpdate()
end

function TableUpdate() 
	LootInfo_MyFrame:SetSize(200,STATIC_SIZE + (CARD_SIZE*MAX_CARDS))
	for i=1, MAX_CARDS do
		local t1 = items[table.getn(items) - (i+(CURRENT_PAGE -1)*MAX_CARDS) + 1]
		local amt = tonumber(amounts[table.getn(items) - (i+(CURRENT_PAGE -1)*MAX_CARDS) + 1])
		if amt ~= nil and amt > 1 then 
			t1 = t1 .. "x" .. amounts[table.getn(items) - (i+(CURRENT_PAGE -1)*MAX_CARDS) + 1]
		end
		SetCardText(i, t1, players[table.getn(items) - (i+(CURRENT_PAGE -1)*MAX_CARDS) + 1])
	end
	if page_num ~= nil then page_num.text1:SetText(CURRENT_PAGE) end
end


function SetCardText(cardNum, t1, t2)

	if cards ~= nil then
		cards[cardNum].text1:SetText(t1)
		cards[cardNum].text2:SetText(t2)
		if t2 ~= nil then
			cards[cardNum]:Show()
			cards[cardNum].edit:Show()
		else 
			cards[cardNum]:Hide()
			cards[cardNum].edit:Hide()
		end
	end

end

function ExportString()
	local str = "Time,Zone,Item,ItemID,Amount,Quality,Player\n"
	for i=1,table.getn(items) do
		local itemName, _, quality, _, _, class, subclass, stackCount, equipSlot, texture, _, ClassID, SubClassID = GetItemInfo(items[i])
		local id = GetItemInfoInstant(items[i]);
		str = str .. times[i] .. "," .. zones[i] .. "," .. itemStr[i] .. "," .. id .. "," .. amounts[i] .. "," .. _if(quality, quality, 0) .. ",".. players[i] .. "\n"
	end
	
	return str
	
end

function _if(bool, T, F)
	if (bool) then
		return T;
	else
		return F;
	end
end
	

function ExportCSV()
	local CopyChat = CreateFrame('Frame', 'nChatCopy', UIParent)
	CopyChat:SetWidth(500)
	CopyChat:SetHeight(400)
	CopyChat:SetPoint('CENTER',0,0)
	CopyChat:SetFrameStrata('DIALOG')
	CopyChat:Hide()
	CopyChat:SetBackdrop({
		bgFile = [[Interface\Buttons\WHITE8x8]],
		insets = {left = 3, right = 3, top = 4, bottom = 3
	}})
	CopyChat:SetBackdropColor(0, 0, 0, 0.7)

	CopyChat.Button1 = CreateFrame("Button", nil, CopyChat, "UIPanelButtonTemplate")
	CopyChat.Button1:SetSize(65,25)
	CopyChat.Button1:SetText("Close")
	CopyChat.Button1:SetPoint("Top",35,25)
	CopyChat.Button1:SetScript("OnClick", function()
		CopyChat:Hide()
	end)
	CopyChat.Button2 = CreateFrame("Button", nil, CopyChat, "UIPanelButtonTemplate")
	CopyChat.Button2:SetSize(65,25)
	CopyChat.Button2:SetText("Select All")
	CopyChat.Button2:SetPoint("Top",-35,25)
	CopyChat.Button2:SetScript("OnClick", function()
		CopyChatBox:SetText(ExportString())
		CopyChatBox:HighlightText(0)
	end)

	CopyChatBox = CreateFrame('EditBox', 'nChatCopyBox', CopyChat)
	CopyChatBox:SetMultiLine(true)
	CopyChatBox:SetAutoFocus(true)
	CopyChatBox:EnableMouse(true)
	CopyChatBox:SetMaxLetters(99999)
	CopyChatBox:SetFont('Fonts\\ARIALN.ttf', 13, 'THINOUTLINE')
	CopyChatBox:SetWidth(590)
	CopyChatBox:SetHeight(590)
	CopyChatBox:SetScript('OnEscapePressed', function() CopyChat:Hide() end)

	local Scroll = CreateFrame('ScrollFrame', 'nChatCopyScroll', CopyChat, 'UIPanelScrollFrameTemplate')
	Scroll:SetPoint('TOPLEFT', CopyChat, 'TOPLEFT', 8, -30)
	Scroll:SetPoint('BOTTOMRIGHT', CopyChat, 'BOTTOMRIGHT', -30, 8)
	Scroll:SetScrollChild(CopyChatBox)
	
	CopyChatBox:SetText(ExportString())
	CopyChatBox:HighlightText(0)
	CopyChat:Show()
	
end

function SetupWindow()
	if cards ~= nil and table.getn(cards) > 0 then 
		for i=1, table.getn(cards) do
			cards[i]:Hide()
			cards[i] = nil
		end
	end
	cards = {}
	local size = table
	for i=1, MAX_CARDS do
		
		local f1 = CreateFrame("Frame",nil,LootInfo_MyFrame)
		f1:SetWidth(175) 
		f1:SetHeight(50) 
		f1:SetAlpha(.90);
		f1:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
		 edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
		 tile = true, tileSize = 16, edgeSize = 16, 
		 insets = { left = 4, right = 4, top = 4, bottom = 4 }});
		f1:SetBackdropColor(0,0,0,1);
		f1:SetPoint("TOP",0,-35 * i + ( (i-1) * -15 ) )
		
		f1.text1 = f1:CreateFontString(nil,"ARTWORK") 
		f1.text1:SetFont("Fonts\\ARIALN.ttf", 13, "OUTLINE")
		f1.text1:SetPoint("CENTER",0,10)
		f1.text1:SetText(i)
		f1:EnableMouse()
		f1:SetScript('OnMouseDown', function()
		GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR")
		GameTooltip:SetHyperlink(items[table.getn(items) - (i+(CURRENT_PAGE -1)*MAX_CARDS) + 1])
		GameTooltip:Show()

		end)
		f1:SetScript('OnLeave', function() GameTooltip:Hide() end)
		
		f1.text2 = f1:CreateFontString(nil,"ARTWORK") 
		f1.text2:SetFont("Fonts\\ARIALN.ttf", 13, "OUTLINE")
		f1.text2:SetPoint("CENTER",0,-10)
		f1.text2:SetText("Hello")
		
		f1:Show()
		
		
		f1.edit = CreateFrame("Button", "MyButton", f1, "UIPanelButtonTemplate")
		f1.edit:SetSize(35 ,22)
		f1.edit:SetText("Edit")
		f1.edit:SetPoint("CENTER",65,-10)
		f1.edit:SetScript("OnClick", function()
			local size = table.getn(items)
			local f = CreateFrame("Button", "FizzleUIGrabTextFrame", nil)
			
			f:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", tile = true, tileSize = 16, insets = {left = 0, right = 0, top = 0, bottom = 0},})
			f:SetBackdropColor(0, 0, 0)
			f:SetPoint("CENTER")
			f:SetSize(250, 25)
			
			print(qualities[size - (i+(CURRENT_PAGE -1)*MAX_CARDS) + 1])
			f.Text = CreateFrame("EditBox", nil, f)
			
			f.Text:SetPoint("TOPRIGHT", -10, -10)
			f.Text:SetPoint("BOTTOMLEFT", 10, 10)
			f.Text:SetMultiLine(false)
			f.Text:SetMaxLetters(25)
			f.Text:SetFontObject(GameFontNormal)
			f.Text:SetText(players[size - (i+(CURRENT_PAGE -1)*MAX_CARDS) + 1])
			f.Button1 = CreateFrame("Button", nil, f, "UIPanelButtonTemplate")
			f.Button1:SetSize(50,25)
			f.Button1:SetText("Save")
			f.Button1:SetPoint("CENTER",-50,-35)
			f.Button2 = CreateFrame("Button", nil, f, "UIPanelButtonTemplate")
			f.Button2:SetSize(50,25)
			f.Button2:SetText("Cancel")
			f.Button2:SetPoint("CENTER",0,-35)
			f.Button3 = CreateFrame("Button", nil, f, "UIPanelButtonTemplate")
			f.Button3:SetSize(50,25)
			f.Button3:SetText("Delete")
			f.Button3:SetPoint("CENTER",50,-35)
			
			f.Button3:SetScript("OnClick", function()
				table.remove(players, table.getn(items) - (i+(CURRENT_PAGE -1)*MAX_CARDS) + 1)
				table.remove(items, table.getn(amounts) - (i+(CURRENT_PAGE -1)*MAX_CARDS) + 1)
				table.remove(amounts, table.getn(amounts) - (i+(CURRENT_PAGE -1)*MAX_CARDS) + 1)
				table.remove(zones, table.getn(zones) - (i+(CURRENT_PAGE -1)*MAX_CARDS) + 1)
				table.remove(itemStr, table.getn(itemStr) - (i+(CURRENT_PAGE -1)*MAX_CARDS) + 1)
				table.remove(times, table.getn(times) - (i+(CURRENT_PAGE -1)*MAX_CARDS) + 1)
				table.remove(qualities, table.getn(qualities) - (i+(CURRENT_PAGE -1)*MAX_CARDS) + 1)
				TableUpdate()
				f:Hide()
				end)
			f.Button2:SetScript("OnClick", function()
				f:Hide()
				end)
			f.Button1:SetScript("OnClick", function()
				players[size - (i+(CURRENT_PAGE -1)*MAX_CARDS) + 1] = f.Text:GetText()
				TableUpdate()
				f:Hide()
				end)
			f.Text:SetScript("OnEnterPressed", function()
				players[size - (i+(CURRENT_PAGE -1)*MAX_CARDS) + 1] = f.Text:GetText()
				TableUpdate()
				f:Hide()
				end)
			f.Text:SetScript("OnEscapePressed", function()
				f:Hide()
			end)
		end)
		
		f1.edit:Hide()
				
		
		
		table.insert(cards, f1)
		
	end
	if page_num ~= nil then page_num:Hide() end
	page_num = CreateFrame("Frame",nil,LootInfo_MyFrame)
	page_num:SetWidth(175) 
	page_num:SetHeight(50) 
	page_num:SetAlpha(.90);
	page_num:SetPoint("BOTTOM",0,0 )
	page_num:SetPoint("CENTER",0,0 )
	page_num.text1 = page_num:CreateFontString(nil,"ARTWORK") 
	page_num.text1:SetFont("Fonts\\ARIALN.ttf", 13, "OUTLINE")
	page_num.text1:SetPoint("CENTER",0,0)
	page_num.text1:SetText(CURRENT_PAGE)
	

	page_num:Show()
	
	TableUpdate()
	
end

